*** applications/aufs/aufs.c.orig	Wed Sep 25 00:10:19 1996
--- applications/aufs/aufs.c		Fri Jul 11 19:29:43 1997
***************
*** 91,96 ****
--- 91,100 ----
  export u_char *srvrtype = (u_char *)AFSTYPE;	/* NBP registered type */
  export char *messagefile = NULL; /* AFP2.1 GetSrvrMsg srvr msg filename */
  export char *motdfile = NULL; /* AFP2.1 GetSrvrMsg login msg filename */
+ export char *dsiTCPIPFilter = NULL; /* AFP2.2 AppleShareIP address filter */
+ export u_int asip_addr = INADDR_ANY; /* AFP2.2 AppleShare over TCP/IP */
+ export u_short asip_port = ASIP_PORT; /* AFP2.2 AppleShare TCP/IP port */
+ export int asip_enable = FALSE; /* AFP2.2 AppleShare TCP/IP default off */
  
  private char *sysvolfile = NULL; /* system afpvols file */
  private char *passwdlookaside = NULL; /* local password file??? */
***************
*** 240,245 ****
--- 244,252 ----
    fprintf(stderr,"\t-V VolsFile for server wide afp volumes\n");
    fprintf(stderr,"\t-G <username> to set guest id for <anonymous> logins\n");
    fprintf(stderr,"\t-P LookAsidePasswordFile for scrambled transactions\n");
+   fprintf(stderr,"\t-T enable AFP connections via TCP/IP (default addr)\n");
+   fprintf(stderr,"\t-B <addr[:port]> enable AFP over TCP/IP & set address\n");
+   fprintf(stderr,"\t-f <filterfile> set the AFP over TCP-IP address filter\n");
    fprintf(stderr,"\t-U <number> to allow <number> sessions\n");
    fprintf(stderr,"\t-m|M <file> specifies login or server message file\n");
  #ifndef STAT_CACHE
***************
*** 297,307 ****
  char **argv;
  {
    int c;
    u_char *parsename();
    extern char *optarg;
    extern int optind;
    extern boolean dochecksum;
!   static char optlist[64] = "a:d:D:n:N:t:kpsuV:U:G:P:c:l:z:S:R:M:m:";
  #ifdef ISO_TRANSLATE
    void cISO2Mac();
  #endif ISO_TRANSLATE
--- 304,315 ----
  char **argv;
  {
    int c;
+   char *p;
    u_char *parsename();
    extern char *optarg;
    extern int optind;
    extern boolean dochecksum;
!   static char optlist[100] = "a:B:d:f:D:n:N:t:kpsTuV:U:G:P:c:l:z:S:R:M:m:";
  #ifdef ISO_TRANSLATE
    void cISO2Mac();
  #endif ISO_TRANSLATE
***************
*** 388,393 ****
--- 396,417 ----
        if (!SetPktTrace(optarg))
  	usage(argv[0]);
        break;
+     case 'f':				/* AppleShareIP IP address filter */
+       dsiTCPIPFilter = optarg;
+       break;
+     case 'B':				/* Bind AppleShare TCP/IP address */
+       if ((p = (char *)index(optarg, ':')) != NULL) {
+ 	asip_port = atoi(p+1);
+ 	*p = '\0';
+       }
+       if ((asip_addr = (u_int)ntohl(inet_addr(optarg))) == -1)
+ 	asip_addr = INADDR_ANY;
+       if (p != NULL)
+ 	*p = ':';
+       /* fall through */
+     case 'T':				/* Enable AppleShare TCP/IP */
+       asip_enable = TRUE;
+       break;
      case 'V':				/* system afpvols file */
        sysvolfile = optarg;
        break;
***************
*** 688,693 ****
--- 712,722 ----
    if ((ctp_stack = (int *)malloc(sizeof(int)*maxsess)) == NULL) {
      logit(0,"couldn't malloc stack for pid recording, fatal!");
    }
+   if (asip_enable)
+     if (asip_addr != INADDR_ANY)
+       logit(0,"AFP over TCP/IP enabled (IP %08x Port %d)",asip_addr,asip_port);
+     else
+       logit(0,"AFP over TCP/IP enabled (IP INADDR_ANY Port %d)", asip_port);
  #ifdef LWSRV_AUFS_SECURITY
    if (userlogindir != NULL) {			/* budd... */
        logit(0,"Aufs: user login database in %s", userlogindir);
***************
*** 725,731 ****
    if (n_rrpkts < atpMaxNum)
      logit(0,"remote limited to %d packet%s in a response", n_rrpkts,
  	n_rrpkts > 1 ? "s" : "");
!   SPGetParms(&mcs, &qs);
    if (DBDEB)
      printf("Command buffer size is %d, Quantum size is %d\n", mcs, qs);
    buf = (byte *)malloc(mcs);
--- 754,760 ----
    if (n_rrpkts < atpMaxNum)
      logit(0,"remote limited to %d packet%s in a response", n_rrpkts,
  	n_rrpkts > 1 ? "s" : "");
!   dsiGetParms(&mcs, &qs);
    if (DBDEB)
      printf("Command buffer size is %d, Quantum size is %d\n", mcs, qs);
    buf = (byte *)malloc(mcs);
***************
*** 783,798 ****
      PrtSrvrInfo(srvinfo,srvinfolen);
    
    /* Init asp */
!   err = SPInit(&addr,srvinfo,srvinfolen,&slsref);
    if (err != noErr) {
!     logit(0,"SPInit failed with code %d, fatal",err);
      exit(0);
    }
  
    logit(0,"Aufs Starting (%s)",srvrname);
    if (sysvolfile)
      logit(0,"System vols in '%s'",sysvolfile);
!   logit(0,"SPInit Completed.  Waiting for connection...");
  
  #ifndef NOSHUTDOWNCODE
  # ifndef NOPGRP
--- 812,827 ----
      PrtSrvrInfo(srvinfo,srvinfolen);
    
    /* Init asp */
!   err = dsiInit(&addr,srvinfo,srvinfolen,&slsref);
    if (err != noErr) {
!     logit(0,"dsiInit failed with code %d, fatal",err);
      exit(0);
    }
  
    logit(0,"Aufs Starting (%s)",srvrname);
    if (sysvolfile)
      logit(0,"System vols in '%s'",sysvolfile);
!   logit(0,"dsiInit Completed.  Waiting for connection...");
  
  #ifndef NOSHUTDOWNCODE
  # ifndef NOPGRP
***************
*** 819,825 ****
  
    do {
      pid = -1;			/* make sure zero at start */
!     SPGetSession(slsref,&cno,&comp);
      if (comp > 0)
        logit(0,"Waiting for session %d to activate", cno);
      /* won't wait if we set comp above */
--- 848,854 ----
  
    do {
      pid = -1;			/* make sure zero at start */
!     dsiGetSession(slsref,&cno,&comp);
      if (comp > 0)
        logit(0,"Waiting for session %d to activate", cno);
      /* won't wait if we set comp above */
***************
*** 848,855 ****
        sesscount++;
        logit(0,"New session %d started on server socket %d, count %d",
  	  cno,slsref,sesscount);
!       if ((err = SPGetNetworkInfo(cno, &addr)) != noErr) {
! 	logit(0,"Get Network info failed with error %d", err);
        } else {
  #ifdef AUTHENTICATE
  	err = (authenticate(ntohs(addr.net), addr.node)) ? noErr : ~noErr;
--- 877,889 ----
        sesscount++;
        logit(0,"New session %d started on server socket %d, count %d",
  	  cno,slsref,sesscount);
!       if ((err = dsiGetNetworkInfo(cno, &addr)) != noErr) {
! 	if (err > 0) { /* AppleShareIP session */
! 	logit(0,"Session %d from [IP addr %d.%d.%d.%d, port %d]",
! 	    cno, addr.net>>8, addr.net&0xff, addr.node, addr.skt, err);
! 	  err = noErr;
! 	} else
! 	  logit(0,"Get Network info failed with error %d", err);
        } else {
  #ifdef AUTHENTICATE
  	err = (authenticate(ntohs(addr.net), addr.node)) ? noErr : ~noErr;
***************
*** 864,870 ****
        }
  #ifdef AUTHENTICATE
        if(err != noErr) {
! 	SPCloseSession(cno, 1, 1, &comp2);
  	continue;
        }
  #endif AUTHENTICATE
--- 898,904 ----
        }
  #ifdef AUTHENTICATE
        if(err != noErr) {
! 	dsiCloseSession(cno, 1, 1, &comp2);
  	continue;
        }
  #endif AUTHENTICATE
***************
*** 889,898 ****
  # endif NOSHUTDOWNCODE;
  #endif NOSIGMASK
        /* fork on connection - only tickle from parent */
!       if ((pid = SPFork(cno, TRUE, FALSE)) < 0) {
! 	logit(0,"SPFork failed on session %d, last system error %d",cno, errno);
  	/* try to close, but don't worry too much */
! 	SPCloseSession(cno, 1, 1, &comp2);
  #ifdef NOSIGMASK
  	sigrelse(SIGCHLD);
  	sigrelse(SIGHUP);
--- 923,932 ----
  # endif NOSHUTDOWNCODE;
  #endif NOSIGMASK
        /* fork on connection - only tickle from parent */
!       if ((pid = dsiFork(cno, TRUE, FALSE)) < 0) {
! 	logit(0,"dsiFork failed on session %d, last system error %d",cno,errno);
  	/* try to close, but don't worry too much */
! 	dsiCloseSession(cno, 1, 1, &comp2);
  #ifdef NOSIGMASK
  	sigrelse(SIGCHLD);
  	sigrelse(SIGHUP);
***************
*** 905,912 ****
  #endif NOSIGMASK
  	continue;
        }
        if (pid) {
- 	SPTickleUserRoutine(cno, timedout, pid);
  	logit(0,"pid %d starting for session %d",pid, cno);
  	addinferior(cno, pid);	/* addinferior scans (phew) */
        } else {
--- 939,946 ----
  #endif NOSIGMASK
  	continue;
        }
+       dsiTickleUserRoutine(cno, timedout, pid);
        if (pid) {
  	logit(0,"pid %d starting for session %d",pid, cno);
  	addinferior(cno, pid);	/* addinferior scans (phew) */
        } else {
***************
*** 997,1003 ****
    umask(0);			/* file creates have explict modes */
    for (;;) {
  #ifndef TREL_TIMEOUT
!     SPGetRequest(cno,buf,mcs,&reqref,&type,&rlen,&comp);
      while (comp > 0) {
        abSleep(sectotick(60),TRUE);
  #ifdef AUFS_IDLE_TIMEOUT
--- 1031,1037 ----
    umask(0);			/* file creates have explict modes */
    for (;;) {
  #ifndef TREL_TIMEOUT
!     dsiGetRequest(cno,buf,mcs,&reqref,&type,&rlen,&comp);
      while (comp > 0) {
        abSleep(sectotick(60),TRUE);
  #ifdef AUFS_IDLE_TIMEOUT
***************
*** 1016,1022 ****
      }
  	    
     if (comp1 <= 0) {
!     SPGetRequest(cno,buf1,mcs,&reqref1,&type1,&rlen1,&comp1);
      while (comp1 > 0) {
        abSleep(sectotick(60),TRUE);
  #ifdef AUFS_IDLE_TIMEOUT
--- 1050,1056 ----
      }
  	    
     if (comp1 <= 0) {
!     dsiGetRequest(cno,buf1,mcs,&reqref1,&type1,&rlen1,&comp1);
      while (comp1 > 0) {
        abSleep(sectotick(60),TRUE);
  #ifdef AUFS_IDLE_TIMEOUT
***************
*** 1034,1043 ****
      }
  #ifndef TREL_TIMEOUT
      if (comp < 0) {
!       logit(0,"SPGetRequest failed %d",comp);
  #else TREL_TIMEOUT
      if (comp1 < 0) {
!       logit(0,"SPGetRequest failed %d",comp1);
  #endif TREL_TIMEOUT
        continue;
      }
--- 1068,1077 ----
      }
  #ifndef TREL_TIMEOUT
      if (comp < 0) {
!       logit(0,"dsiGetRequest failed %d",comp);
  #else TREL_TIMEOUT
      if (comp1 < 0) {
!       logit(0,"dsiGetRequest failed %d",comp1);
  #endif TREL_TIMEOUT
        continue;
      }
***************
*** 1079,1108 ****
        }
  #ifndef TREL_TIMEOUT
        if (type == aspWrite)
! 	SPWrtReply(cno,reqref,(dword) err,rspbuf,rsplen,&comp);
  #else TREL_TIMEOUT
        if (type1 == aspWrite)
! 	SPWrtReply(cno,reqref1,(dword) err,rspbuf1,rsplen1,&comp1);
  #endif TREL_TIMEOUT
        else
  #ifndef TREL_TIMEOUT
! 	SPCmdReply(cno,reqref,(dword) err,rspbuf,rsplen,&comp);
        while (comp > 0) {
  	abSleep(sectotick(60),TRUE);
        }
        if (DBSRV)
  	printf("done\n");
  #else TREL_TIMEOUT
! 	SPCmdReply(cno,reqref1,(dword) err,rspbuf1,rsplen1,&comp1);
  #endif TREL_TIMEOUT
        break;
      case aspCloseSession:
        logit(0,"Closing ASP Session...");
  #ifndef TREL_TIMEOUT
!       SPCloseSession(cno,10,3,&comp); /* 5 times, .75 seconds */
        while (comp > 0)
  #else TREL_TIMEOUT
!       SPCloseSession(cno,10,3,&comp1); /* 5 times, .75 seconds */
        while (comp1 > 0)
  #endif TREL_TIMEOUT
  	abSleep(1, TRUE);
--- 1113,1142 ----
        }
  #ifndef TREL_TIMEOUT
        if (type == aspWrite)
! 	dsiWrtReply(cno,reqref,(dword) err,rspbuf,rsplen,&comp);
  #else TREL_TIMEOUT
        if (type1 == aspWrite)
! 	dsiWrtReply(cno,reqref1,(dword) err,rspbuf1,rsplen1,&comp1);
  #endif TREL_TIMEOUT
        else
  #ifndef TREL_TIMEOUT
! 	dsiCmdReply(cno,reqref,(dword) err,rspbuf,rsplen,&comp);
        while (comp > 0) {
  	abSleep(sectotick(60),TRUE);
        }
        if (DBSRV)
  	printf("done\n");
  #else TREL_TIMEOUT
! 	dsiCmdReply(cno,reqref1,(dword) err,rspbuf1,rsplen1,&comp1);
  #endif TREL_TIMEOUT
        break;
      case aspCloseSession:
        logit(0,"Closing ASP Session...");
  #ifndef TREL_TIMEOUT
!       dsiCloseSession(cno,10,3,&comp); /* 5 times, .75 seconds */
        while (comp > 0)
  #else TREL_TIMEOUT
!       dsiCloseSession(cno,10,3,&comp1); /* 5 times, .75 seconds */
        while (comp1 > 0)
  #endif TREL_TIMEOUT
  	abSleep(1, TRUE);
***************
*** 1133,1139 ****
  #endif NOSHUTDOWNCODE;
  #ifdef TREL_TIMEOUT
     } else {  /* comp2 */
!     SPGetRequest(cno,buf2,mcs,&reqref2,&type2,&rlen2,&comp2);
      while (comp2 > 0) {
        abSleep(sectotick(60),TRUE);
  #ifdef AUFS_IDLE_TIMEOUT
--- 1167,1173 ----
  #endif NOSHUTDOWNCODE;
  #ifdef TREL_TIMEOUT
     } else {  /* comp2 */
!     dsiGetRequest(cno,buf2,mcs,&reqref2,&type2,&rlen2,&comp2);
      while (comp2 > 0) {
        abSleep(sectotick(60),TRUE);
  #ifdef AUFS_IDLE_TIMEOUT
***************
*** 1149,1155 ****
        return;
      }
      if (comp2 < 0) {
!       logit(0,"SPGetRequest failed %d",comp2);
        continue;
      }
      if (rlen2 == 0)
--- 1183,1189 ----
        return;
      }
      if (comp2 < 0) {
!       logit(0,"dsiGetRequest failed %d",comp2);
        continue;
      }
      if (rlen2 == 0)
***************
*** 1173,1185 ****
  	fflush(stdout);			/* force out */
        }
        if (type2 == aspWrite)
! 	SPWrtReply(cno,reqref2,(dword) err,rspbuf2,rsplen2,&comp2);
        else
! 	SPCmdReply(cno,reqref2,(dword) err,rspbuf2,rsplen2,&comp2);
        break;
      case aspCloseSession:
        logit(0,"Closing ASP Session...");
!       SPCloseSession(cno,10,3,&comp2); /* 5 times, .75 seconds */
        while (comp2 > 0)
  	abSleep(1, TRUE);
  #ifndef NOSHUTDOWNCODE
--- 1207,1219 ----
  	fflush(stdout);			/* force out */
        }
        if (type2 == aspWrite)
! 	dsiWrtReply(cno,reqref2,(dword) err,rspbuf2,rsplen2,&comp2);
        else
! 	dsiCmdReply(cno,reqref2,(dword) err,rspbuf2,rsplen2,&comp2);
        break;
      case aspCloseSession:
        logit(0,"Closing ASP Session...");
!       dsiCloseSession(cno,10,3,&comp2); /* 5 times, .75 seconds */
        while (comp2 > 0)
  	abSleep(1, TRUE);
  #ifndef NOSHUTDOWNCODE
***************
*** 1300,1308 ****
        logit(0,"process %d, session %d was suspended! gads what is happening?",
  	  cp->pid, srn);
      } else if (WIFSIGNALED(cp->status)) {
!       SPAttention(srn, AFPSHUTDOWNNOW, 1, -1, &comp);
        while (comp > 0) {abSleep(30, TRUE);} /* ignore error */
!       SPCloseSession(srn, 3, 2, &comp); /* try 3 times every .5 seconds */
        while (comp > 0) { abSleep(30, TRUE); } /* close down if we can */
        logit(0,"process %d, session %d was terminated on signal %d",
  	  cp->pid, srn, W_TERMSIG(cp->status));
--- 1334,1342 ----
        logit(0,"process %d, session %d was suspended! gads what is happening?",
  	  cp->pid, srn);
      } else if (WIFSIGNALED(cp->status)) {
!       dsiAttention(srn, AFPSHUTDOWNNOW, 1, -1, &comp);
        while (comp > 0) {abSleep(30, TRUE);} /* ignore error */
!       dsiCloseSession(srn, 3, 2, &comp); /* try 3 times every .5 seconds */
        while (comp > 0) { abSleep(30, TRUE); } /* close down if we can */
        logit(0,"process %d, session %d was terminated on signal %d",
  	  cp->pid, srn, W_TERMSIG(cp->status));
***************
*** 1321,1327 ****
        logit(0,"process %d, session %d terminated with exit code %d",
  	  cp->pid, srn, W_RETCODE(cp->status));
      }
!     SPShutdown(srn);
      nomoresessions = FALSE;	/* if this was set, unset now */
  #ifdef DORUSAGE
      logit(0,"%d messages out, %d in, CPU %.2f user %.2f system",
--- 1355,1361 ----
        logit(0,"process %d, session %d terminated with exit code %d",
  	  cp->pid, srn, W_RETCODE(cp->status));
      }
!     dsiShutdown(srn);
      nomoresessions = FALSE;	/* if this was set, unset now */
  #ifdef DORUSAGE
      logit(0,"%d messages out, %d in, CPU %.2f user %.2f system",
***************
*** 1385,1391 ****
    /* assume sigchild interlocked here */
    if (ctp_tab[srn].state & CP_RUNNING)
      ctp_tab[srn].state |= CP_TIMEDOUT;
!   SPShutdown(srn);		/* ignore errors */
    kill(pid, SIGHUP);		/* hangup inferior */
  }
  
--- 1419,1425 ----
    /* assume sigchild interlocked here */
    if (ctp_tab[srn].state & CP_RUNNING)
      ctp_tab[srn].state |= CP_TIMEDOUT;
!   dsiShutdown(srn);		/* ignore errors */
    kill(pid, SIGHUP);		/* hangup inferior */
  }
  
***************
*** 1399,1408 ****
    /* The following shouldn't really do anything since remote should be gone */
    /* be in case it really isn't, let's go through this rigamorle */
    /* Tell remote we are shutting down */
!   SPAttention(cno, AFPSHUTDOWNNOW, 1, -1, &comp);
    while (comp > 0) {abSleep(30, TRUE);} /* ignore error */
    /* Try closing just in case */
!   SPCloseSession(cno, 3, 2, &comp); /* 3 times, .5 seconds */
    while (comp > 0) { abSleep(30, TRUE); } /* close down if we can */
  #ifdef LWSRV_AUFS_SECURITY
    clearuserlogin(); /* gtw: delete auth-file entry for dead users */
--- 1433,1442 ----
    /* The following shouldn't really do anything since remote should be gone */
    /* be in case it really isn't, let's go through this rigamorle */
    /* Tell remote we are shutting down */
!   dsiAttention(cno, AFPSHUTDOWNNOW, 1, -1, &comp);
    while (comp > 0) {abSleep(30, TRUE);} /* ignore error */
    /* Try closing just in case */
!   dsiCloseSession(cno, 3, 2, &comp); /* 3 times, .5 seconds */
    while (comp > 0) { abSleep(30, TRUE); } /* close down if we can */
  #ifdef LWSRV_AUFS_SECURITY
    clearuserlogin(); /* gtw: delete auth-file entry for dead users */
***************
*** 1431,1437 ****
    /* Tell remote we are shutting down */
    if (minutes_to_shutdown % 2) {		/* all odd minutes */
      /* there is a potential race condition here */
!     SPAttention(cno, AFPSHUTDOWNTIME(minutes_to_shutdown), 1, -1, &comp);
      while (comp > 0) {abSleep(30, TRUE);} /* ignore error */
    }
    minutes_to_shutdown--;
--- 1465,1471 ----
    /* Tell remote we are shutting down */
    if (minutes_to_shutdown % 2) {		/* all odd minutes */
      /* there is a potential race condition here */
!     dsiAttention(cno, AFPSHUTDOWNTIME(minutes_to_shutdown), 1, -1, &comp);
      while (comp > 0) {abSleep(30, TRUE);} /* ignore error */
    }
    minutes_to_shutdown--;
***************
*** 1465,1471 ****
    int comp;
  
    signal(SIGURG, SIG_IGN);
!   SPAttention(cno, AFPSERVERMESG, 1, -1, &comp);
    while (comp > 0)
      abSleep(30, TRUE);
    signal(SIGURG, msgavail);
--- 1499,1505 ----
    int comp;
  
    signal(SIGURG, SIG_IGN);
!   dsiAttention(cno, AFPSERVERMESG, 1, -1, &comp);
    while (comp > 0)
      abSleep(30, TRUE);
    signal(SIGURG, msgavail);
***************
*** 1893,1899 ****
    if (cmp == 0 && *buf != 17) { /* periodic GetVolParms AFP call */
      if (sentshutdown) {
        logit(0, "Session %d: Aborting Idle Timeout", cno);
!       SPAttention(cno, AFPSHUTDOWNCANCEL, 1, -1, &comp);
        while (comp > 0) { abSleep(30, TRUE); } /* ignore error */
        sentshutdown = 0;
      }
--- 1927,1933 ----
    if (cmp == 0 && *buf != 17) { /* periodic GetVolParms AFP call */
      if (sentshutdown) {
        logit(0, "Session %d: Aborting Idle Timeout", cno);
!       dsiAttention(cno, AFPSHUTDOWNCANCEL, 1, -1, &comp);
        while (comp > 0) { abSleep(30, TRUE); } /* ignore error */
        sentshutdown = 0;
      }
***************
*** 1922,1937 ****
      case 12: /* shutdown in 3 min */
      case 24: /* shutdown in 1 min */
        logit(0, "Session %d: sending %d minute idle timeout warning",cno,5-i/6);
!       SPAttention(cno, AFPSHUTDOWNTIME(5-i/6), 1, -1, &comp);
        while (comp > 0) { abSleep(30, TRUE); } /* ignore error */
        sentshutdown++;
        return;
        break;
      case 30: /* shutdown now */
        logit(0, "Session %d: Idle Timeout Shutdown", cno);
!       SPAttention(cno, AFPSHUTDOWNNOW, 1, -1, &comp);
        while (comp > 0) { abSleep(30, TRUE); } /* ignore error */
!       SPCloseSession(cno, 3, 2, &comp); /* 3 times, .5 seconds */
        while (comp > 0) { abSleep(30, TRUE); } /* close down if we can */
  #ifdef LWSRV_AUFS_SECURITY
        clearuserlogin(); /* gtw: delete auth-file entry for dead users */
--- 1956,1971 ----
      case 12: /* shutdown in 3 min */
      case 24: /* shutdown in 1 min */
        logit(0, "Session %d: sending %d minute idle timeout warning",cno,5-i/6);
!       dsiAttention(cno, AFPSHUTDOWNTIME(5-i/6), 1, -1, &comp);
        while (comp > 0) { abSleep(30, TRUE); } /* ignore error */
        sentshutdown++;
        return;
        break;
      case 30: /* shutdown now */
        logit(0, "Session %d: Idle Timeout Shutdown", cno);
!       dsiAttention(cno, AFPSHUTDOWNNOW, 1, -1, &comp);
        while (comp > 0) { abSleep(30, TRUE); } /* ignore error */
!       dsiCloseSession(cno, 3, 2, &comp); /* 3 times, .5 seconds */
        while (comp > 0) { abSleep(30, TRUE); } /* close down if we can */
  #ifdef LWSRV_AUFS_SECURITY
        clearuserlogin(); /* gtw: delete auth-file entry for dead users */
*** applications/aufs/Makefile.m4.orig	Wed Sep 25 00:09:57 1996
--- applications/aufs/Makefile.m4	Mon Jul  7 02:03:26 1997
***************
*** 48,59 ****
  	afpmisc.c afpserver.c aufsicon.c abmisc2.c \
  	afpdt.c afpdid.c afposenum.c  afpavl.c \
  	afposfi.c afpgc.c afppasswd.c afposlock.c aufsv.c \
! 	afpudb.c afposncs.c afpspd.c afpfid.c
  OBJS=afpos.o afpvols.o afpfile.o \
  	afpmisc.o afpserver.o aufsicon.o abmisc2.o \
  	afpdt.o afpdir.o afpfork.o afpdid.o afposenum.o afpavl.o \
  	afposfi.o afpgc.o afppasswd.o aufsv.o \
! 	afpudb.o afposncs.o afpspd.o afpfid.o
  SYMLINKS=att_getopt.c
  
  all:	aufs sizeserver afpidsrvr afpidlist afpidtool
--- 48,59 ----
  	afpmisc.c afpserver.c aufsicon.c abmisc2.c \
  	afpdt.c afpdid.c afposenum.c  afpavl.c \
  	afposfi.c afpgc.c afppasswd.c afposlock.c aufsv.c \
! 	afpudb.c afposncs.c afpspd.c afpfid.c afpdsi.c
  OBJS=afpos.o afpvols.o afpfile.o \
  	afpmisc.o afpserver.o aufsicon.o abmisc2.o \
  	afpdt.o afpdir.o afpfork.o afpdid.o afposenum.o afpavl.o \
  	afposfi.o afpgc.o afppasswd.o aufsv.o \
! 	afpudb.o afposncs.o afpspd.o afpfid.o afpdsi.o
  SYMLINKS=att_getopt.c
  
  all:	aufs sizeserver afpidsrvr afpidlist afpidtool
***************
*** 189,191 ****
--- 189,193 ----
  afppasswd.o:    afppasswd.c	$I/netat/sysvcompat.h afppasswd.h
  afposncs.o:	afposncs.c	$I/netat/appletalk.h $I/netat/afp.h \
  				afposncs.h afps.h
+ afpdsi.o:	afpdsi.c	$I/netat/appletalk.h ../../lib/cap/abasp.h \
+ 				afpdsi.h
*** lib/afp/afppacks.c.orig		Wed Sep 25 00:10:07 1996
--- lib/afp/afppacks.c			Mon Mar  3 17:34:40 1997
***************
*** 615,620 ****
--- 615,622 ----
    PAKB(GVPRPPtr,P_DWRD,gvpr_free,VP_FREE), /* free bytes */
    PAKB(GVPRPPtr,P_DWRD,gvpr_size,VP_SIZE), /* size in bytes */
    PKSB(GVPRPPtr,P_OSTR,gvpr_name,VP_NAME), /* name of volume */
+   PKSB(GVPRPPtr,P_BYTS,gvpr_efree,VP_EFREE), /* extended free bytes */
+   PKSB(GVPRPPtr,P_BYTS,gvpr_esize,VP_ESIZE), /* extended total bytes */
    PACKEND()
  };
  
***************
*** 663,668 ****
--- 665,673 ----
    PACK(GSIRPPtr, P_OPTR, sr_vicono),
    PACK(GSIRPPtr, P_WORD, sr_flags),
    PAKS(GSIRPPtr, P_PATH, sr_servername),
+   PACKEVEN(),
+   PACK(GSIRPPtr, P_OPTR, sr_sigo),
+   PACK(GSIRPPtr, P_OPTR, sr_naddro),
    PACKEND()
  };
  
*** lib/cap/abasp.c.orig		Thu Mar 14 13:47:51 1991
--- lib/cap/abasp.c			Fri Jul 11 18:20:13 1997
***************
*** 18,25 ****
   *  Aug   4, 1986    CCKim	Verified: level 0
  */
  
- /* PATCH: Moy@Berkeley/abasp.c.diff, djh@munnari.OZ.AU, 17/11/90 */
- 
  #include <stdio.h>
  #include <sys/types.h>
  #include <netinet/in.h>
--- 18,23 ----
***************
*** 61,78 ****
  private void start_client_aspskt();
  private void shutdown_aspskt();
  
! private ASPQE *create_aq();
  private ASPQE *get_aq();
- private void delete_aq();
  private boolean match_aspwe();
  private ASPQE *find_aspawe();
  
  private void startasptickle();
! private void stopasptickle();
  private void ttimeout();
  private void start_ttimer();
  private void reset_ttimer();
! private void stop_ttimer();
  
  int SPFork();
  OSErr SPShutdown();
--- 59,76 ----
  private void start_client_aspskt();
  private void shutdown_aspskt();
  
! void delete_aq();
! ASPQE *create_aq();
  private ASPQE *get_aq();
  private boolean match_aspwe();
  private ASPQE *find_aspawe();
  
  private void startasptickle();
! void stopasptickle();
  private void ttimeout();
  private void start_ttimer();
  private void reset_ttimer();
! void stop_ttimer();
  
  int SPFork();
  OSErr SPShutdown();
***************
*** 89,98 ****
  #ifdef ASPPID
  private ASPSkt *aspskt_find_pid();
  #endif
- private ASPSkt *aspskt_find_active();
- private ASPSkt *aspskt_find_sessrefnum();
  private OSErr aspsskt_new();
! private ASPSSkt *aspsskt_find_slsrefnum();
  private boolean aspsskt_isactive();
  
  private void sizeof_abr_bds_and_req();
--- 87,96 ----
  #ifdef ASPPID
  private ASPSkt *aspskt_find_pid();
  #endif
  private OSErr aspsskt_new();
! ASPSkt *aspskt_find_active();
! ASPSkt *aspskt_find_sessrefnum();
! ASPSSkt *aspsskt_find_slsrefnum();
  private boolean aspsskt_isactive();
  
  private void sizeof_abr_bds_and_req();
***************
*** 1896,1901 ****
--- 1894,1900 ----
        stopasptickle(as);
      }
      ATPCloseSocket(sas->addr.skt); /* close down server listener here */
+     dsiTCPIPCloseSLS(); /* and the AppleShareIP SLS */
    }
    return(pid);
  }
***************
*** 2093,2099 ****
  }
  #endif
  
! private ASPSkt *
  aspskt_find_active(SLSRefNum)
  int SLSRefNum;
  {
--- 2092,2098 ----
  }
  #endif
  
! ASPSkt *
  aspskt_find_active(SLSRefNum)
  int SLSRefNum;
  {
***************
*** 2106,2112 ****
    return(NULL);
  }
  
! private ASPSkt *
  aspskt_find_sessrefnum(srn)
  int srn;
  {
--- 2105,2111 ----
    return(NULL);
  }
  
! ASPSkt *
  aspskt_find_sessrefnum(srn)
  int srn;
  {
***************
*** 2137,2143 ****
  }
  
  
! private ASPSSkt *
  aspsskt_find_slsrefnum(sls)
  int sls;
  {
--- 2136,2148 ----
  }
  
  
! /*
!  * locate SLSRefNum structure
!  * (non-private for DSI access)
!  *
!  */
! 
! ASPSSkt *
  aspsskt_find_slsrefnum(sls)
  int sls;
  {
***************
*** 2212,2218 ****
   * stopasptickle - cancel the tickle on the specified connection
   *
  */
! private void
  stopasptickle(as)
  ASPSkt *as;
  {
--- 2217,2223 ----
   * stopasptickle - cancel the tickle on the specified connection
   *
  */
! void
  stopasptickle(as)
  ASPSkt *as;
  {
***************
*** 2277,2283 ****
   * cancel the remote tickle timeout
   *
  */
! private void
  stop_ttimer(as)
  ASPSkt *as;
  {
--- 2282,2288 ----
   * cancel the remote tickle timeout
   *
  */
! void
  stop_ttimer(as)
  ASPSkt *as;
  {
***************
*** 2291,2297 ****
  private ASPQE *aspqe_list;
  private QElemPtr aspqe_free;
  
! private ASPQE *
  create_aq(which, as)
  int which;
  ASPSkt *as;
--- 2296,2302 ----
  private ASPQE *aspqe_list;
  private QElemPtr aspqe_free;
  
! ASPQE *
  create_aq(which, as)
  int which;
  ASPSkt *as;
***************
*** 2320,2326 ****
    return(aspqe);
  }
  
! private void
  delete_aq(aspqe, which, as)
  ASPQE *aspqe;
  int which;
--- 2325,2331 ----
    return(aspqe);
  }
  
! void
  delete_aq(aspqe, which, as)
  ASPQE *aspqe;
  int which;
*** lib/cap/absched.c.orig		Wed Sep 25 00:10:17 1996
--- lib/cap/absched.c			Wed Jul  9 16:07:49 1997
***************
*** 704,709 ****
--- 704,711 ----
      }
      if (dbug.db_skd)
        fprintf(stderr,"%d ", rdy);
+     if (rdy < 0)
+       return(rdy);
      if (rdy > 0) {
        /* rdy should be # of set file descriptors in the masks */
        /* since we only pass it the "read" bits, this loop */
*** etc/aufsIPFilter.orig	Mon Jul 14 13:46:44 1997
--- etc/aufsIPFilter		Mon Jul 14 13:49:11 1997
***************
*** 0 ****
--- 1,26 ----
+ #
+ # aufs/AppleShareIP Address Access Filter List
+ #
+ # NB: The filter file format is compatible with that used by the ARNS
+ # Remote Access package (http://www.cs.mu.OZ.AU/appletalk/atalk.html)
+ #
+ # The filter list consists of a single character mode, an IP mask and
+ # optional IP address. If the latter is included, the mask is applied
+ # to the incoming IP address and tested against the provided address.
+ # Otherwise the incoming IP address must be unchanged by the mask.
+ #
+ # Modes:
+ #
+ # * IP_MASK [ IP_ADDR ]		permit access
+ # + IP_MASK [ IP_ADDR ]		permit access
+ # - IP_MASK [ IP_ADDR ]		deny access
+ #
+ #
+ # any mac on a specific subnet
+ + 255.255.255.0    192.43.207.0
+ # connections from ariel
+ * 128.250.255.255  128.250.20.3
+ # anybody on campus
+ + 128.243.255.255
+ # nobody else
+ - 255.255.255.255
*** samples/ash.c.orig			Wed Sep 25 00:10:10 1996
--- samples/ash.c			Mon Jul 14 14:27:33 1997
***************
*** 1090,1092 ****
--- 1090,1102 ----
    *bp++ = '\0';
    return(buf);
  }
+ 
+ /*
+  * this is a dummy routine for abasp.c
+  *
+  */
+ 
+ dsiTCPIPCloseSLS()
+ {
+   return(noErr);
+ }
*** netat/afp.h.orig			Wed Sep 25 00:09:55 1996
--- netat/afp.h				Tue Mar  4 14:40:34 1997
***************
*** 192,207 ****
  
  /* Volume Params */
  
! #define VP_ATTR  0001		/* attributes */
! #define VP_SIG   0002		/* signature byte */
! #define VP_CDATE 0004		/* creation date */
! #define VP_MDATE 0010		/* modification date */
! #define VP_BDATE 0020		/* backup date */
! #define VP_VOLID 0040		/* volume id */
! #define VP_FREE  0100		/* free bytes */
! #define VP_SIZE  0200		/* size in bytes */
! #define VP_NAME  0400		/* volume name */
! #define VP_ALL  (0777)
  
  #define VOL_VAR_DIRID 0x03	/* volume has variable dirids */
  #define VOL_FIXED_DIRID 0x02	/* volume has fixed dirids */
--- 192,209 ----
  
  /* Volume Params */
  
! #define VP_ATTR  00001		/* attributes */
! #define VP_SIG   00002		/* signature byte */
! #define VP_CDATE 00004		/* creation date */
! #define VP_MDATE 00010		/* modification date */
! #define VP_BDATE 00020		/* backup date */
! #define VP_VOLID 00040		/* volume id */
! #define VP_FREE  00100		/* free bytes */
! #define VP_SIZE  00200		/* size in bytes */
! #define VP_NAME  00400		/* volume name */
! #define VP_EFREE 01000		/* AFP2.2: extended free bytes */
! #define VP_ESIZE 02000		/* AFP2.2: extended total bytes */
! #define VP_ALL  (03777)
  
  #define VOL_VAR_DIRID 0x03	/* volume has variable dirids */
  #define VOL_FIXED_DIRID 0x02	/* volume has fixed dirids */
***************
*** 278,282 ****
--- 280,286 ----
  #define UIP_PRIMARY_GID 0x2	/* primary group (dword) */
  
  #define AFSTYPE "AFPServer"	/* NBP type for AFS */
+ 
+ #define ASIP_PORT 548		/* AppleShare over TCP/IP well-known port */
  
  char *afperr();			/* in afperr.c */
*** netat/afpcmd.h.orig			Wed Sep 25 00:09:56 1996
--- netat/afpcmd.h			Tue Mar  4 13:22:33 1997
***************
*** 279,285 ****
--- 279,290 ----
  #define SupportsChgPwd     0x02	/* AFP2.0: can do change password */
  #define DontAllowSavePwd   0x04	/* AFP2.1: user can't save password */
  #define SupportsServerMsgs 0x08	/* AFP2.1: can send server messages */
+ #define SupportsServerSig  0x10	/* AFP2.2: can supply unique signature */
+ #define SupportsTCPIP      0x20	/* AFP2.2: AFP commands via TCP/IP stream */
+ #define SupportsSrvrNotif  0x40	/* AFP2.2: server to client messages */
    byte sr_servername[33];	/* server name */
+   byte *sr_sigo;		/* AFP2.2: offset to signature */
+   byte *sr_naddro;		/* AFP2.2: offset to network address count */
  } GetSrvrInfoReplyPkt, *GSIRPPtr;
  
  typedef struct {		/* FPGetSrvrParms */
***************
*** 319,324 ****
--- 324,331 ----
    sdword gvpr_size;		/* size of volume in bytes */
    sdword gvpr_free;		/* free bytes on volume */
    byte gvpr_name[MAXVLEN];	/* advertised name */
+   byte gvpr_esize[8];		/* extended volume size */
+   byte gvpr_efree[8];		/* extended bytes free */
  } GetVolParmsReplyPkt, *GVPRPPtr;
  
  
